#
import urllib
import sys, struct, os.path

# ==============================================================================
# U T I L I T I E S
# ==============================================================================
# ******************************************************************************
# upens a url or file
# ******************************************************************************
def furl_open(fname):
    f = 0
    if 'http:' in fname:
        try:
            f = urllib.urlopen(fname)
        except:
            print "Cant open url:"
            print fname
    else:
        try:
            f = open(fname, "rb")
        except:
            print "Cant open file:",fname
    return f

# ******************************************************************************
# Opens a local file or a url and returns with a list of lines
# ******************************************************************************
def get_lines(fname):
    rv = []
    f = furl_open(fname)
    if f:
        for line in f:
            rv.append(line.rstrip())
            #print "line=", line.rstrip()
    rv.append('') # needs an extra CR at end
    return rv


def main(inpdir,outf):
    print "Input directory {} Output file {}".format(inpdir,outf)
    fnNames = []
    fnComment = []
    if os.path.exists(inpdir):
        directory = os.listdir(inpdir)
        for inpf in directory:
            if '.bas' in inpf:
                print "File: ",inpf
                lines = get_lines(inpdir+'\\'+inpf)
                for l in range(0,len(lines)):
                    f = lines[l].find('function')
                    comment = lines[l].find('//')
                    if (f >=0 and (comment < 0)) or (f >=0 and comment > f):
                        fnName = lines[l][9:lines[l].find(')')+1]  # just function name
                        # get comments above
                        ccount = l-1
                        tmp1 = []
                        if not '// *' in lines[ccount] or '//*' in lines[ccount]:
                            tmp1.append('No comment for this function')
                        else:
                            ccount -= 1
                            while ccount >= 0:
                                tmp1.append(lines[ccount][3:])
                                ccount -= 1
                                if '// *' in lines[ccount] or '//*' in lines[ccount]:
                                    break
                        tmp1.reverse()
                        commentStr = ('#'+str(l)+' '+fnName).ljust(40)
                        commentStr += '['+inpf+']\n'
                        for tt in tmp1:
                            commentStr += tt + '\n'
                        fnComment.append(commentStr)
                        # adding line number makes function name unique fr later
                        fnNames.append(fnName[0:fnName.find('(')]+'#'+str(l)) # just name
        fList = fnNames[:] # copy list
        fList.sort()
        print "Saving to ",inpdir+'\\'+outf
        of = open(inpdir+'\\'+outf,"wb")
        for s in fList:
            of.write(s+'\n')
        of.write('\n')    
        for fn in fList:
            comment = [i for i, s in enumerate(fnNames) if fn in s]
            of.write(fnComment[comment[0]]+'\n')
        of.close()
    else:
        print 'Directory {} does not exists'.format(inpdir)                


if __name__ == '__main__':
    inpf = sys.argv[1]
    outf = sys.argv[2]
    if len(sys.argv) <> 4:
        print
        print " -------- uasage ---------------"
        print "Creates a help file for use with man.bas."
        print "python bypicman.py <directory> <output file>"
        print "It will parse all of the .bas files in the given directory and"
        print "create an output file that can be used with man.bas A '.' can"
        print "be specified for the current directory"
        print "The output file will be created in the input directory"
        print
    main (inpf,outf)
