//
// Responsible for loading rookie and start up files, will only save once as
// lookup is used
// *****************************************************************************
// Automaticlly loads system files into flash to create the system. The files
// will only be loaded once because of the lookup function. In the line
// flsave("sss") the "sss" is specified so that thsi program "main.bas" will
// not be saved along with the rest of the loaded file.
// This is just the loader program, the main program is main1.bas
function main0()
    syslog("main0","Checking loaded files")
    if lookup("ROOKIE1") = 0 then
        syslog("main","** Loading Rookie 1 **")
        fload("MX340_rookie1.bas")
        flsave("ROOKIE1")
    endif
    if lookup("ROOKIE2") = 0 then
        syslog("main0","** Loading Rookie 2 **")
        fload("MX340_rookie2.bas")
        flsave("ROOKIE2")
        reset
    endif 
    // specific to particular hardware  
    if lookup("HARDWARE") = 0 then
        syslog("main0","** Loading BPS12 Hardware Information **")
        fload("BPS12_V0_hardware.bas")
        flsave("HARDWARE")
    endif
    // controls most of Wi-Fi card
    if lookup("RM04") = 0 then
        syslog("main0","** Loading Main Utils **")
        fload("RM04.bas")
        flsave("RM04")
        reset
    endif
    // higher level IP etc..
    if lookup("NETUTILS") = 0 then
        syslog("main0","** Loading NetUtils **")
        fload("netutils.bas")
        flsave("NETUTILS")
    endif
    // web server
    if lookup("WEBSERVER_F") = 0 then
        syslog("main0","** Loading WebServer_e **")
        fload("webserver_f.bas")
        flsave("WEBSERVER_F")
        reset
    endif
    // This is the file that has the input from the browser to server
    // functions - i.e. when a button is pressed the processing is done here
    if lookup("WEBINPUT") = 0 then
        syslog("main0","** Loading webinput **")
        fload("webinput.bas")
        flsave("WEBINPUT")
        reset
    endif
    frun("main1.bas","go","")
endf
