// functions that process input from the web browser
//
constant WEBINPUT 1 // indicater that it is loaded and start of this file
//
// The web server uses two globals
// page$    is the name of the requested page or function, this will be 
//          processed by the web server and call a function here
// line$    is any parameters for that page (function), in this case the
//          function will parse this line and take action
// *****************************************************************************
// This is for the web server demonstration
// *****************************************************************************
function ledReq()
dim p=0, led, v=0
    led = str2int(token$(line$,?p,'=')) // get led number
    if mid$(line$,p,5) = "ON" then
        v=1
    endif        
    if led = 1 then 
        ledL1(v)
    endif                
    if led = 2 then 
        ledL2(v)
    endif 
    return 0 // called with exec() must return something               
endf

// *****************************************************************************
// relay action, turn on relays when a button is pressed, note that only
// one button at once can be pressed
// line$ =  n=ON or n=OFF
// typical: 2=ON
// *****************************************************************************
function ht_relay1()
dim p=0, pin
    pin = str2int(token$(line$,?p,'=')) // get pin number
    if (pin < 7) && (pin >= 0) then
        if mid$(line$,p,3) = "ON" then
            io_write(PORTB,pin,LOW)
        endif
        if mid$(line$,p,3) = "OFF" then
            io_write(PORTB,pin,HIGH)
        endif
    endif
    return 0
endf

// *****************************************************************************
// relay action, turn on relays when a button is pressed, note that only
// one button at once can be pressed
// line$ =  n=ON or n=OFF
// typical: 2=ON
// *****************************************************************************
function ht_relay2()
dim p=0, pin
    pin = str2int(token$(line$,?p,'=')) // get pin number
    if (pin < 7) && (pin >= 0) then
        if mid$(line$,p,3) = "ON" then
            io_write(PORTD,pin,LOW)
        endif
        if mid$(line$,p,3) = "OFF" then
            io_write(PORTD,pin,HIGH)
        endif
    endif
    return 0
endf

// *****************************************************************************
// Handles web page when lcd is sent -- 20x4
// line$ = L1=<display text>&L2=<display textt>....
// No test is a blank string
// Typical 1=text&2=&3=&4=
// *****************************************************************************
function lcd_page20x4()
dim this$[35],lcdline, p=0, p1
    while p >=0
        this$ = token$(line$,?p,'&') // get line info
        p1=0
        lcdline=str2int(token$(this$,?p1,'=')) // get 1, 2 etc
        //print format$("\nlcdline$=[%d]",lcdline())
        //print format$("\nlcd text=[%s]",mid$(this$,p1,200))
        select(lcdline)
            case(1)
                lcd_rc(0,0)
                break
            case(2)
                lcd_rc(1,0)
                break
            case(3)
                lcd_rc(2,0)
                break
            case(4)
                lcd_rc(3,0)
                break
        endselect
        if strlen(mid$(this$,p1,200)) = 0 then
            lcd_puts("                   ")
        else
            lcd_puts(mid$(this$,p1,200))
        endif
    wend
    return 0
endf

// *****************************************************************************
// Handles web page when lcd is sent -- 16x2
// line$ = L1=<display text>&L2=<display textt>....
// No test is a blank string
// Typical 1=text&2=
// *****************************************************************************
function lcd_page16x2()
dim this$[35],lcdline, p=0, p1
    while p >=0
        this$ = token$(line$,?p,'&') // get line info
        p1=0
        lcdline=str2int(token$(this$,?p1,'=')) // get 1, 2 etc
        //print format$("\nlcdline$=[%d]",lcdline())
        //print format$("\nlcd text=[%s]",mid$(this$,p1,200))
        select(lcdline)
            case(1)
                lcd_rc(0,0)
                break
            case(2)
                lcd_rc(1,0)
                break
        endselect
        if strlen(mid$(this$,p1,200)) = 0 then
            lcd_puts("               ")
        else
            lcd_puts(mid$(this$,p1,200))
        endif
    wend
    return 0
endf

