// This file contains all of the hardware information, it is used for 
// initialisation and so should be loaded first
// BPS12 PCB Version 0
//
constant HARDWARE 1 // indicater that it is loaded and start of this file
// control port and baud rate, baud rate set by config
constant CPORT 1    // UART to use for control
constant CBAUD 115200
// this pin places the wi-fi module into mode 0 or mode 1
constant ESPIN  1   // RE1
constant ESPORT PORTE
constant LF 10
// LEDS
constant LEDCON     6
constant LEDCONp    PORTF
constant LEDERR     11
constant LEDERRp    PORTB
constant LEDL1      10
constant LEDL1p     PORTB
constant LEDL2      2
constant LEDL2p     PORTE

// *****************************************************************************
// set i/o as required
// *****************************************************************************
function init_hardware()
dim j
    com1_open(CBAUD,800) // open/reopen with bigger buffer
    // pin for changing wi fi mode
    io_write(ESPORT,ESPIN,HIGH) // es/RST active low
    io_pinMode(ESPORT,ESPIN,OUT,WOFF)
    // led outputs
    io_write(LEDCONp,LEDCON,HIGH) // leds high is off
    io_write(LEDERRp,LEDERR,HIGH)
    io_write(LEDL1p,LEDL1,HIGH)
    io_write(LEDL2p,LEDL2,HIGH)
    //
    io_pinMode(LEDCONp,LEDCON,OUT,WOFF)
    io_pinMode(LEDERRp,LEDERR,OUT,WOFF)
    io_pinMode(LEDL1p,LEDL1,OUT,WOFF)
    io_pinMode(LEDL2p,LEDL2,OUT,WOFF)
endf

//******************************************************************************
// translates a 0 to HIGH and 1 to LOW 
//******************************************************************************
function getHL(oon)
    if oon = 0 then
        oon = HIGH
    else
        oon = LOW
    endif
    return oon
endf    

//******************************************************************************
// led indicators 0 = off 1 = onn
//******************************************************************************
function ledCon(oon)
    io_write(LEDCONp,LEDCON,getHL(oon))
endf    
function ledErr(oon)
    io_write(LEDERRp,LEDERR,getHL(oon))
endf    
function ledL1(oon)
    io_write(LEDL1p,LEDL1,getHL(oon))
endf    
function ledL2(oon)
    io_write(LEDL2p,LEDL2,getHL(oon))
endf    


