// Version for BV503 - to be loaded from SD Card, no # values
// rookie.bas
// Load this and save to flash. It is intended for first time users of ByPic
// that makes it much simpler for basic tasks to be carried out
// Processor BV513 - MX3
// Version see main()
//
//
constant ROOKIE2 1 // indicater that it is loaded and start of this file
// =============================================================================
// BV513 Specific items
// bridge and so it is this line that will tell BV_COMM to stop
// transmitting when the device is busy
//
constant RTS    14    // this goes to CTS on the FTDI chip (RB14)
// *****************************************************************************
// for any binary transfer the CTS-RTS habdshake needs setting
// *****************************************************************************
function rts_on()
    io_pinMode(PORTB,RTS,OUT,WOFF) // set o/p
    comrts(2,PORTB+PORT_OFF,RTS) // PORT+PORT_OFF for actual port
endf
// *****************************************************************************
// turns the on board LED on and off, C15 is set to output on startup, from
// main
// *****************************************************************************
function led_on()
    io_write(PORTC, 15, LOW)
endf
function led_off()
    io_write(PORTC, 15, HIGH)
endf

// =============================================================================
// a few(one) file utilities
// =============================================================================
// *****************************************************************************
// this is missing from the normal file functions
// *** Note string limited to 128
// *****************************************************************************
function fputs(s$[128], f)
dim w, len = strlen(s$)
    if fwrite(s$,len,?w,f) <> 0 then
        print "\nFile write error"
    endif
endf

// =============================================================================
// Start up
constant SYS_STRLEN 80 // default string length
//constant SYS_COMBAUD 115200 // set to different if required
constant SYS_FLAG 0xffffffb8 // just error messages

// *****************************************************************************
// add any other items here to your own start up
// *****************************************************************************
//function main()
//    print "\n***********************************************"
//    print "\n* BV513 _ rookie installed V2.1               *"
//    print "\n  MX3 Version  "
//    print VERSION$,"                        *"
//    print "\n* Details www.bypic.co.uk/library/rookie/     *"
//    print "\n* To clear type flclear(0)                    *"
//    print "\n***********************************************"
//    io_write(PORTC, 15, HIGH)
//    io_pinMode(PORTC, 15, OUT, WOFF) // set on board LED Port to o/p
//    IrFlag = 0
//endf

