// This is the simplified version for the simple web server
// Use this as a platform for development
//
// To use this module it is assumed that the configuration is set and that
// the wi-fi module is up and running
//
// *****************************************************************************
// called after loader.bas. loader.bas makes sure that all the required 
// functions are in flash ready to use.
// Note that the version of rookie on the SD Card does not have a 'main' this
// is it.
// *****************************************************************************
function go()
dim a$, j
    // any hardware that needs initialising
    syslog("main1","Start")
    fcd("/") // root
    init() // general initialisation (again)
    IrFlag = 0 // rookie needs this
    ledL1(1) // l1 indicates main1 running
    ledCon(0)
    ledErr(0)
    print "\nWait...."
    // check that the module has booted up by trying to set mode. At first
    // switchin this can take up to 30 seconds
    for j = 1 to 12
        if Mode(1) <> 0 then
            break
        else
            syslog("main1",format$("Waiting for wi-fi module <%d>",j))
        endif
    next
    // may as well update config
    updateCfg("default.cfg")
    // this is where the wi-fi modules connects to the infrastructure - or not
    // connect can take about 30 seconds if an update has taken place
    for j = 1 to 15
        syslog("main1",format$("Waiting for wifi connect <%d>",j))
        if connected() = 1 then
            ledCon(1)
            break
        endif
        wait(100)
    next
    // can now set date and time if required, must beconnected to internet
    // though so as this is not known it is commented out
//    if set_netmode(-1) <> 3 then // AP will not be connected to internet
//        checkDT() // also sets it
//    endif
    // makes sure in server mode and also sets Mode to 0 (not at mode)
    setServer(8000)
    //
    print "\nMain 1 ready for V2.08 - 28"
    print "\nUse ini() - to reconnect to com1"
    print "\nprint connected() - returns 1 if connected to module"
    print "\nMode(1) - for acess to module AT commands via cmd$(<command>)"
    print "\nUse Mode(0) - after, Mode(1) should return <> 0"
    print "\nupdateCfg(\"default.cfg\") - will update the module config"
    print "\nwait for 30 seconds after this, it may disconnect the socket"
    print "\nmay need to reconnect to server in which case setServer(8000)"
    print "\n"
    print "\ncheckDT()-to set date and time, only if internet connection avail"
    print "\nhelp - for a list of functions"
    print "\nThe web server should be running so press enter to break out"
    print "\nUse dos to run the server again\n"
    
    dos()
endf

