// Simple webserver 
// This is intended to be as simple as possible no attemt at optimisation 
// has been made
//
// Version f incorporates a watchdog timer
// 
constant WEBSERVER_F 1 // this file id
constant tempFile$ "wptemp.html"
constant LMAX   160 // max size of lines

// watch dog
constant WDTCLR         0xBF800004
constant WDTSET         0xBF800008 // wdtcomset
constant WDSW           (1 << 15)
constant WDCLR          1

// globals - dealing with large strings, because of the limited ram, some
// globals are used and re-used
// NOTE: locals take up some overhead so temporary globals used
dim line$[LMAX], page$[LMAX], s$[LMAX], echo$[LMAX], root$[LMAX]

// =============================================================================
// =============================================================================
// *****************************************************************************
// HEAD
// All web clients (browsers) expect a head similar to this before sending a 
// page, for this version of HTML the length must be known beforehand
// *****************************************************************************
function head(length)
    syslog("head",format$("Page length %d",length))
    comouts(CPORT,"HTTP/1.0 200 OK\r\n")
    comouts(CPORT,"Content-type: text/html\r\n")
    comouts(CPORT,format$("Content-Length: %d\r\n",length))
    comouts(CPORT,"Last-Modified: Fri, 14 Mar 2014 10:28:08 GMT\r\n")
    comouts(CPORT,"Connection: Close\r\n")
    comouts(CPORT,"Date: Fri, 14 Mar 2014 10:33:24 GMT\r\n")
    comouts(CPORT,"Server: BV503 Server\r\n")
//    comouts(CPORT,"Connection: Keep-Alive\r\n")
//    comouts(CPORT,"Keep-Alive: timeout=2,max=200\r\n")
//    comouts(CPORT,"Connection: close\r\n")
    comouts(CPORT,"\r\n")
endf

// *****************************************************************************
// sends file back to browser, this will normally be a web page that has been
// constructed by the page process.
// The file must of course exist on the SD card
// *****************************************************************************
function send_page(pageName$[60])
dim k, f
    syslog("send_page", format$("Sending %s",pageName$))
    f = fopen(pageName$,"r")
    if f <> 0 then
        // send head with size of text to send
        head(fsize(f))
        // send body
        k = fgets(line$,f)
        while k = 0
            // just send line of text to UART
            comouts(CPORT,line$)
            k = fgets(line$,f)
        wend
        comouts(CPORT,"\r\n")
        fclose(f)
    else
        syslog("send_page", format$("Cant open %s not found",pageName$))
    endif
endf

// *****************************************************************************
// This is an actual page of the SD card
// <?bypic
// ?>
// *****************************************************************************
function create_tempFile(infname$[60],inf,outf)
dim k, k1, p, p1, newpos, w, len
    syslog("create_tempFile", format$("source %s",infname$))
    k = fgets(s$,inf)
    while k = 0
//print "\n",s$
        // check for inline bypic code, outputs to echo$
        p=pos(s$,"<?bypic")
        if p >= 0 then // <?bypic found
            if p > 0 then //  some text in front of <?bypic
                // write up to <?bypic
                len = strlen(mid$(s$,0,p))
                if fwrite(mid$(s$,0,p),len,?w,outf) <> 0
                    syslog("create_tempFile", "file write error")
                endif
            endif
            p = p + 7
            p1 = pos(s$,"?>")
            if p1 > 0 then // terminates on same line
                echo$=""
                interpret(mid$(s$,p,p1-p))
                len = strlen(echo$)
                if fwrite(echo$,len,?w,outf) <> 0
                    syslog("create_tempFile", "file write error")
                endif
                len = strlen(mid$(s$,p1+2,120))
                if fwrite(mid$(s$,p1+2,120),len,?w,outf) <> 0
                    syslog("create_tempFile", "file write error")
                endif
            else
                // process not inline, e.g
                // <?bypic
                // ....
                // ?>
                // This uses floadp that will interpret from a file
       //print "\npos",fpos(inf)
                newpos=floadp(infname$,fpos(inf),"?>")
       //print "\nnewpos",newpos
                if newpos  < 0 then
                    syslog("create_tempFile",format$("Error from floadp %s",infname$))
                else
                    fseek(newpos,inf)
                endif
            endif
        else
            // no <?bypic so just normal line
            len = strlen(s$)
            if fwrite(s$,len,?w,outf) <> 0
                    syslog("create_tempFile", "file write error")
            endif
        endif
        k = fgets(s$,inf)  // next line
    wend
endf

// *****************************************************************************
// sends requested page to server, if not found then sends the not found
// page
// Two globals used
// page$ is the name of the requesrted page
// line$ is any parameters for that page, will be "" if none
// *****************************************************************************
function process_page()
dim inf, outf
syslog("process_page", format$("Processing page %s",page$))
    inf = fopen(page$,"r")
    if inf <> 0 then
        outf = fopen(tempFile$,"w") // create temporaty file
        if outf <> 0 then
            // create a temport file that will be op to webbrowser
            create_tempFile(page$,inf,outf)
            fclose(outf)
            fclose(inf)
            send_page(tempFile$)
        else
            syslog("process_page", format$("Tempory file %s error",tempFile$))
        endif
    else
        // cant actually find that page
        send_page("not_found.html")
    endif
endf

// *****************************************************************************
// a function should exist somwhere that will process the request
// Two globals used
// page$ is the name of the requesrted page or function
// line$ is any parameters for that page, will be "" if none
// *****************************************************************************
function process_get()
dim adr
syslog("process_get", format$("Page %s",page$))    
syslog("process_get", format$("Request %s",line$))
    adr = lookup(page$)
    if adr <> 0 then
        exec(adr)
        page$=root$ // reprocess original html file
        line$=""
        process_page() // must send back something
    else
        syslog("process_get", format$("Function %s not found",page$))
    endif    
endf

// *****************************************************************************
// service request. This can be called at regular intervals to service any
// requests that have come in
// *****************************************************************************
function http_server()
dim p=0
    page$ = getLine$(LF) // get first lineof request    
    if strlen(page$) <> 0 then
        syslog("http_server", "---------Web Server Start ---------")
        // wait for "\n\r" at end of head
        while strlen(getLine$(LF)) <> 0
        wend
        syslog("http_server","server_request$="+page$)
        s$ = token$(page$,?p,'/') // should be GET^
        if p > 0 then
            comclear(CPORT) // clear rest of head
            if s$ = "GET " then
                // this is the request after GET/ which could be:
                // nothing GET / HTTP/1.1
                // just a page GET /page HTTP/1.1
                // a page page with params GET /page?1=on&2=on HTTP/1.1
                s$ = token$(page$,?p,'/') // gump GET
                // check for params
                p=pos(page$,"?")
                if p >= 0 then
                    // it has parameters so pass to action
                    p=0
                    page$ = token$(s$,?p,'?') // get page name
                    line$ = token$(s$,?p,' ') // line has parameters
                    process_get()
                    process_page()
                else
                    // no parameters so is either blank or a page name
                    p=0
                    line$="" // no params
                    page$ = token$(s$,?p,' ') // get page name
                    root$=page$ // this may be needed later
                    if strlen(page$) = 0 then
                        // nothing following GET so it the index
                        page$="index.html"
                    endif
                    process_page()
                endif
            endif // s$, GET
        endif //p
    endif
endf

// for testing
function dos()
    fcd("\web")
    comclear(CPORT)
    @WDTSET = WDSW // set up watch dog timer
    while comkey?(2) = 0
        // wait for full line
        if bpos(CPORT,0,"\r") > 0 then
            http_server()
        endif
        @WDTSET = WDCLR // clear watch dog
        wait(100)
    wend
    ledL2(0)
    @WDTCLR = WDSW // turn off watchdog
endf       

